/////////////////////////////////////////////////////////////
//Created by Garthor on Saturday, August 31, 2002, 10:38 PM//
//                                                         //
//This can be used to easily create a starry backround for //
//any space-based game you wish to make.  Simply place the //
//space turf anywhere, and it will be filled with stars.   //
//Set the range vars to determine how many stars will be   //
//created on each turf.                                    //
/////////////////////////////////////////////////////////////

world/hub = "Garthor.StarMapper"

turf
	space
		//The icon for the space turf will be generated at runtime, in New(), so that an RGB file can be used instead of an icon file.
		var/range1 = 2 //Sets the range for the number of stars in each turf.
		var/range2 = 6
		var/weight = 2 //Sets the weighting for the number of stars.  When set higher, the number of stars in each tile tends to be closer to
						// the average of range1 and range2.  Try to keep it under range1.  Must be above 0.  Experiment with it if you want.
		var/starnum
		New()
			icon = 'Black.dmi' //The turf has a black backround, which is needed (because the new icon operator is picky).
			sleep(round(src.x)/4) //Used to keep all the stars from being created at once.  At higher numbers of stars, adjust the delay accordingly to prevent lock-up.
			var/stars
			for(var/W = weight,W,W--)
				stars += rand(range1/weight,range2/weight) //So the weight takes effect.
			stars = round(stars) //So we have a whole number.
			starnum = stars //Used to count the number of stars.
			while(stars)
				var/icon/I = new('Pixel.dmi',icon_state = pick("1",prob(30);"2",prob(15);"3",prob(4);"4")) //This file contains a few pixels in the bottom left.  It's the basis for a star.
				var/R = rand(150,255)
				var/G = R
				var/B = R //These two can be randomized as well, but the color of stars is white from the distance you would be seeing them from.  Change if you wish.
				I.SwapColor(rgb(0,0,0),rgb(R,G,B)) //So there's a SLIGHT variety in the colors of the stars.  Edit if you want.
				I.Shift(NORTH,rand(0,29)) //Shifts the single pixel to a random position on the turf.  I'd use pixel_x and pixel_y, but icon vars don't like those.
				I.Shift(EAST,rand(0,29))
				var/icon/O = new(src.icon) //Create a temporary icon to add the new icon onto.
				O.Blend(I,ICON_OVERLAY) //Adds the star to the temporary icon.
				src.icon = O //And send the icon back.
				stars--